#include <display_syscalls.h>
#include <stdio.h>
#include "bitmap.h"



void CopySpriteNbitMasked(const unsigned char* data, int x, int y, int width, int height, const unsigned short* palette, unsigned short maskColor, unsigned int bitwidth);
void* GetVRAMAdress();


int main() 
{	
	BITMAP image = Init_BITMAP();

	LoadBmp24_to8bits("Example1/A.bmp",&image);
	if (image.error8bit == ERR_NOERROR)
	{
		Bdisp_AllClr_VRAM();
		CopySpriteNbitMasked(image.sprite8Bit,0,0,image.width,image.height, image.sprite8Bit_palette,0x0000,8);
		Bdisp_PutDisp_DD();
	}
	Delete_BITMAP(&image);
	LoadBmp24_to8bits("Example1/B.bmp",&image);
	if (image.error8bit == ERR_NOERROR)
	{
		Bdisp_AllClr_VRAM();
		CopySpriteNbitMasked(image.sprite8Bit,0,0,image.width,image.height, image.sprite8Bit_palette,0x0000,8);
		Bdisp_PutDisp_DD();
	}
	Delete_BITMAP(&image);
	LoadBmp24_to8bits("Example1/C.bmp",&image);
	if (image.error8bit == ERR_NOERROR)
	{
		Bdisp_AllClr_VRAM();
		CopySpriteNbitMasked(image.sprite8Bit,0,0,image.width,image.height, image.sprite8Bit_palette,0x0000,8);
		Bdisp_PutDisp_DD();
	}
	Delete_BITMAP(&image);
	LoadBmp24_to8bits("Example1/D.bmp",&image);
	if (image.error8bit == ERR_NOERROR)
	{
		Bdisp_AllClr_VRAM();
		CopySpriteNbitMasked(image.sprite8Bit,0,0,image.width,image.height, image.sprite8Bit_palette,0x0000,8);
		Bdisp_PutDisp_DD();
	}
	Delete_BITMAP(&image);
	LoadBmp24_to8bits("Example1/E.bmp",&image);
	if (image.error8bit == ERR_NOERROR)
	{
		Bdisp_AllClr_VRAM();
		CopySpriteNbitMasked(image.sprite8Bit,0,0,image.width,image.height, image.sprite8Bit_palette,0x0000,8);
		Bdisp_PutDisp_DD();
	}
	Delete_BITMAP(&image);
	Delete_BITMAP(&image);

	return 0;
}














void CopySpriteNbitMasked(const unsigned char* data, int x, int y, int width, int height, const unsigned short* palette, unsigned short maskColor, unsigned int bitwidth)
{
   unsigned short* VRAM = (unsigned short*)GetVRAMAdress();
   VRAM += (384*y + x);
   int offset = 0;
   unsigned char buf=0;
   int i,j;
   for(j=y; j<y+height; j++)
   {
      int availbits = 0;
      for(i=x; i<x+width;  i++)
      {
         if (!availbits)
         {
            buf = data[offset++];
            availbits = 8;
         }
         unsigned short thiss = ((unsigned short)buf>>(8-bitwidth));
         unsigned short color = palette[thiss];
         if(color != maskColor && i<384 && i>=0)
         {
            *VRAM = color;
         }
         VRAM++;
         buf<<=bitwidth;
         availbits-=bitwidth;
      }
      VRAM += (384-width);
   }
}


void* GetVRAMAdress()
{
	asm("mov.l syscall_adress, r2\n"
	    "mov.l getVRAM, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress: .long 0x80020070\n"
	    "getVRAM: .long 0x01E6");
}